﻿' VB2008 hat diese 3 generischen Delegaten bereits deklariert - daher sollten 
'  sie bei Verwendung von VB2008 nicht noch einmal deklariert werden.
#Region "Delegaten"
Public Delegate Sub Action()
Public Delegate Sub Action(Of T1, T2)(ByVal Arg1 As T1, _
                                      ByVal Arg2 As T2)
Public Delegate Sub Action(Of T1, T2, T3)(ByVal Arg1 As T1, _
                                          ByVal Arg2 As T2, _
                                          ByVal Arg3 As T3)
#End Region

''' <summary>
''' Stellt Methoden bereit, mit denen ein beliebiger Methoden-Aufruf mit bis zu 
'''  drei Argumenten in einen Nebenthread verlegt werden kann, bzw. aus einem 
'''  Nebenthread in den Hauptthread.
''' </summary>
Public Class CrossThread

    Public Shared Sub RunAsync(Of T1, T2, T3)( _
            ByVal Action As Action(Of T1, T2, T3), _
            ByVal Arg1 As T1, _
            ByVal Arg2 As T2, _
            ByVal Arg3 As T3)

        ' Aufruf von Action.EndInvoke() gewährleisten, indem er als 
        '  Callback-Argument mitgegeben wird
        Action.BeginInvoke(Arg1, Arg2, Arg3, _
                           AddressOf Action.EndInvoke, Nothing)
    End Sub
    Public Shared Sub RunAsync(Of T1, T2)(ByVal Action As Action(Of T1, T2), _
                                          ByVal Arg1 As T1, ByVal Arg2 As T2)
        Action.BeginInvoke(Arg1, Arg2, AddressOf Action.EndInvoke, Nothing)
    End Sub
    Public Shared Sub RunAsync(Of T1)(ByVal Action As Action(Of T1), _
                                      ByVal Arg1 As T1)
        Action.BeginInvoke(Arg1, AddressOf Action.EndInvoke, Nothing)
    End Sub
    Public Shared Sub RunAsync(ByVal Action As Action)
        Action.BeginInvoke(AddressOf Action.EndInvoke, Nothing)
    End Sub

    Private Shared Function GuiCrossInvoke(ByVal Action As [Delegate], _
            ByVal ParamArray Args() As Object) As Boolean

        If Application.OpenForms.Count = 0 Then
            ' Wenn kein Form mehr da ist, so tun, als ob das Invoking 
            '  ausgeführt wäre
            Return True
        End If
        If Application.OpenForms(0).InvokeRequired Then
            Application.OpenForms(0).BeginInvoke(Action, Args)
            Return True
        End If
    End Function

    Public Shared Sub RunGui(Of T1, T2, T3)( _
            ByVal Action As Action(Of T1, T2, T3), _
            ByVal Arg1 As T1, _
            ByVal Arg2 As T2, _
            ByVal Arg3 As T3)

        ' Falls Invoking nicht erforderlich, die Action direkt ausführen
        If Not GuiCrossInvoke(Action, Arg1, Arg2, Arg3) Then
            Action(Arg1, Arg2, Arg3)
        End If
    End Sub
    Public Shared Sub RunGui(Of T1, T2)(ByVal Action As Action(Of T1, T2), _
                                        ByVal Arg1 As T1, ByVal Arg2 As T2)
        If Not GuiCrossInvoke(Action, Arg1, Arg2) Then Action(Arg1, Arg2)
    End Sub
    Public Shared Sub RunGui(Of T1)(ByVal Action As Action(Of T1), _
                                    ByVal Arg1 As T1)
        If Not GuiCrossInvoke(Action, Arg1) Then Action(Arg1)
    End Sub
    Public Shared Sub RunGui(ByVal Action As Action)
        If Not GuiCrossInvoke(Action) Then Action()
    End Sub

End Class
